package com.zt.plat.module.qms.business.reportdoc.service;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.business.reportdoc.controller.vo.*;
import com.zt.plat.module.qms.business.reportdoc.dal.dataobject.ReportDocumentTypeDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 报告类型配置 Service 接口
 *
 * @author 后台管理
 */
public interface ReportDocumentTypeService {

    /*保存数据*/
    CommonResult<String> save(@Valid ReportDocumentTypeSaveReqVO reqV);
    CommonResult<String> saveWithNewVersion(@Valid ReportDocumentTypeSaveReqVO reqV);

    /**
     * 创建报告类型配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ReportDocumentTypeRespVO createReportDocumentType(@Valid ReportDocumentTypeSaveReqVO createReqVO);

    /**
     * 更新报告类型配置
     *
     * @param updateReqVO 更新信息
     */
    void updateReportDocumentType(@Valid ReportDocumentTypeSaveReqVO updateReqVO);

    /**
     * 删除报告类型配置
     *
     * @param id 编号
     */
    void deleteReportDocumentType(Long id);

    /**
     * 批量删除报告类型配置
     *
     * @param ids 编号
     */
    void deleteReportDocumentTypeListByIds(List<Long> ids);

    /**
     * 获得报告类型配置
     *
     * @param id 编号
     * @return 报告类型配置
     */
    ReportDocumentTypeDO getReportDocumentType(Long id);

    /**
     * 获得报告类型配置分页
     *
     * @param pageReqVO 分页查询
     * @return 报告类型配置分页
     */
    PageResult<ReportDocumentTypeDO> getReportDocumentTypePage(ReportDocumentTypePageReqVO pageReqVO);

    List<ReportDocumentTypeDO> selectListWithPermission(ReportDocumentTypePageReqVO pageReqVO);

}